Replacing model parts with a Component

Hi to all, I’m pretty new to Sketchup modeling.

So my story, I have modeled a Tree it’s in obj format. Converted to .skp using Deep Exploration.

To make it Low Poly, the foliage concist of pretty big intersected faces and when I’m rendering I’m getting this black spots. it’s to dense for the light to go through, but I don’t want to increase lights.

What I’m trying to do, is to replace this parts with another ones and make all of them same component copies.
I mean I’m gonna draw a new component similar to those foliage but more optimized.

My question:

is it any solution that I can replace all existing foliage parts with my new foliage component?

more automatically, not deleting and copy my new component and placing it manually.

Thanks a lot!

select all you want to replace, then Right click the new one in Component Browser, you should see an option to replace all with component…

john

1 Like

Thank you John!

I’ve tried the method.
It’s ok but guess only when you already have the old foliage as Components.

In my model because it was modeled in another software and converted/imported all the foliage consist from many similar leafs that are not components.

The tree consists from:

  1. Foliage (all parts are not componts) and consists from many leaf like #3 bellow
    2.Trunk
  2. Leaf, it’s a component

So when I right click on my new component in menu, I see only Select Instances:

And when I click Select Instances, only my new component #3 is selected :slight_smile:

PS the new component leaf has smaller faces, more polygons so i need to replace old big faces leafs to make place for the light to go through easier.

Can you change the model in the other software so the parts of it that need to be components in Sketchup are components? Otherwise you’ll need to go through the model in SketchUp and make the components so they can be replaced. Or maybe the tree can be edited in Deep Exploration so there’s more gaps for light to pass through.

be easier if you post the skp file here…

if the old one are groups, they can be converted to components quite easily with code or a plugin…

model  = Sketchup.active_model
defs   = model.definitions
ents   = model.active_entities
sel    = model.selection
grps   = sel.to_a
grps.each{|g| sel.add(g.to_component)}

john

It’s a tree modeled in SpeedTree, so can’t be made as components as I know, but all Leaves are grouped.

Will post in a minute.

https://dl.dropboxusercontent.com/u/14584371/African_Sumac%20ultimul.skp

unfortunately, because they are a single group I think manual is the only option…

john

yes John, all of them was exported as a single group.

Manual :slight_smile: this one has ~2k leaves, I have a big pine also with many many needles :laughing:

I was trying the TreeMaker for Sketchup, but it’s so limited.

Will post what solution I found, if I will of cause :slight_smile:

So after few tests and forum reads, I can now all my bunch of leaves make components or groups.

But if I have 1000 leaves, I can now make 1000 groups or 1000 components.

Because all leaves are same, I would like to have One component with 1000 instances.
Much appreciated if any ideas will be shared.

Probably since I’m looking for a more automatic solution I could replace all my leaves manually and make them instances :slight_smile: , but now I’m more interested if it’s possible to find a solution for this.

Till now I used:
Chris Fullmer Loose to groups plugin
and
ThomThom Convert groups to Components plugin.

if you have 1000 components…

then select all, go to the component in the comp browser and select one and use the replace selected option I showed in my gif…

or post your file if it doesn’t work…

john

John, thank you

I have tried your suggestion earlier, it replace all components, make same amount of instances, but with one issue, all instances have a wrong orientation.
In other words, initially all leaves ware oriented to branches, after conversion all new instances have same orientation with first component.

if the groups where made after being placed then I can see how that would occur…

I’ll have a think…

john

Yes, after that

I have the model in obj format, converted it to skp

and all leaves was converted to groups in sketchup with this plugin:
http://extensions.sketchup.com/content/clf-loose-groups

Update

so what I have now: a tree model with let’s say 1000 leaves. All leaves are groups or components (1000 groups or components).

What I can’t find is how to do this two:

  1. How to replace all leafs (which are components or groups now) with one component, so at the end I’ll have 1 component with 1000 instances/copies.
    Or with other words how to make all leafs/components/groups to be instances of the same component ( 1 component with 1000 instances)

  2. How to replace all existing leafs /components/groups with another component?
    What I mean is I have now a low poly leaf, I want to replace it with a higher poly leaf, but to keep initial orientation of replaced leaf.
    What I found till now few plugins, all didn’t keep the initial orientation.

To be honest, it is pretty near impossible to impose a hierarchy of repeated components and sub-components onto a model that effectively has no hierarchy to begin with…especially something as complex and organic as a tree.
It’s not exactly impossible, but it would be so time-consuming and finicky that you’d be better off simply starting from scratch.
It is possible to make reasonable-looking, low-poly trees directly, by hand in SketchUp.

OR you could use a plugin like treemaker.
https://extensions.sketchup.com/en/content/3d-tree-maker

Alan,

Treemaker, is pretty limited, I mean it’s ok for modeling some non very complex or generic trees, but to model a real existing botanically correct tree I found ti very difficult.

A real existing Tree in SpeedTree takes about 5 hours to model (modeling, making textures etc)

That’s why I went another way, SpeedTree -> export obj/fbx -> import in Sketchup
(another advantaje of using SpeedTree is that it can save instantly many variations of same tree)

The problem is with dense foliage, to keep low poly, I’m using large faces, but the bad part is when rendering (SU Podium) the light doesn’t pass through this big faces very well and make some black spots.

Yes, I agree…Treemaker is pretty limited; it doesn’t always produce the most realistic-looking trees either. That’s why I make my own manually using repeated components. By producing a series of varying image files you can also produce seasonal variations of the same tree…or switch the kind of leaf to produce a completely different one.
It can often be done in a lot less that 5 hours too. These are all variants of the same basic mesh, produced by simply switching the leaf texture map.
http://www.formfonts.com/3D-Model/1/12948/1/life-forms/h30-plants/geometree-006/

I don’t know what the stats are for the SpeedTree mesh, but even after editing it’s probably considerably more than the above examples. You can also use purely transparent images for the entire branch components which can bring the overall poly count down to just a few hundred. They look pretty good too…but don’t display properly in some renderers. The Geometrees that I linked to are pure geometry with diamond shapes for the leaves, so would render in just about anything.

Building your own is not as lengthy as it might seem. A half dozen different branch components can be scaled and assembled into a massive range of more complex boughs. There are also some free or very cheap tree modelers around that can be used to produce an entire tree…just don’t bother saving anything beyond the trunk and main branches. You don’t actually need the gazillions of tiny twigs; they are just there so the algorithm can know where to lace the leaves.

As for the leaves, just start with one in SketchUp, then make a few copies and arrange them at random angles in a component…then duplicate the component several times and arrange those copies at random angles. You end up with thousands of leaves quite quickly by multiplying-up in this way.
I tend to build a bare tree than simply populate it with “clouds” of several hundred leaves until it looks good and I achieve the density I’m after. It’s not really apparent that the leaves aren’t actually physically connected to anything. The eye just assumes they are.